## vectorscan 5.4.6

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8.11)
project (vectorscan C CXX)

set (HS_MAJOR_VERSION 5)
set (HS_MINOR_VERSION 4)
set (HS_PATCH_VERSION 6)
set (HS_VERSION ${HS_MAJOR_VERSION}.${HS_MINOR_VERSION}.${HS_PATCH_VERSION})

set(CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake)
include(CheckCCompilerFlag)
include(CheckCXXCompilerFlag)
include(CheckCXXSymbolExists)
INCLUDE (CheckFunctionExists)
INCLUDE (CheckIncludeFiles)
INCLUDE (CheckIncludeFileCXX)
INCLUDE (CheckLibraryExists)
INCLUDE (CheckSymbolExists)
include (CMakeDependentOption)
include (GNUInstallDirs)
include (${CMAKE_MODULE_PATH}/platform.cmake)
include (${CMAKE_MODULE_PATH}/ragel.cmake)

find_package(PkgConfig QUIET)

if (NOT CMAKE_BUILD_TYPE)
    message(STATUS "Default build type 'Release with debug info'")
    set(CMAKE_BUILD_TYPE RELWITHDEBINFO CACHE STRING "" FORCE )
else()
    string(TOUPPER ${CMAKE_BUILD_TYPE} CMAKE_BUILD_TYPE)
    message(STATUS "Build type ${CMAKE_BUILD_TYPE}")
endif()

if(CMAKE_BUILD_TYPE MATCHES NONE|RELEASE|RELWITHDEBINFO|MINSIZEREL)
    message(STATUS "using release build")
    set(RELEASE_BUILD TRUE)
else()
    set(RELEASE_BUILD FALSE)
endif()

set(BINDIR "${PROJECT_BINARY_DIR}/bin")
set(LIBDIR "${PROJECT_BINARY_DIR}/lib")

set(INCLUDE_INSTALL_DIR ${CMAKE_INSTALL_INCLUDEDIR})

# First for the generic no-config case
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${BINDIR}")
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${LIBDIR}")
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY "${LIBDIR}")
# Second, for multi-config builds (e.g. msvc)
foreach (OUTPUTCONFIG ${CMAKE_CONFIGURATION_TYPES})
    string (TOUPPER ${OUTPUTCONFIG} OUTPUTCONFIG)
    set(CMAKE_RUNTIME_OUTPUT_DIRECTORY_${OUTPUTCONFIG} "${BINDIR}")
    set(CMAKE_LIBRARY_OUTPUT_DIRECTORY_${OUTPUTCONFIG} "${LIBDIR}")
    set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY_${OUTPUTCONFIG} "${LIBDIR}")
endforeach (OUTPUTCONFIG CMAKE_CONFIGURATION_TYPES)


if(CMAKE_GENERATOR STREQUAL Xcode)
    set(XCODE TRUE)
endif()

# older versions of cmake don't know things support isystem
if (XCODE OR CMAKE_CXX_COMPILER_ID MATCHES "Intel")
    set(CMAKE_INCLUDE_SYSTEM_FLAG_CXX "-isystem")
endif ()

set(CMAKE_INCLUDE_CURRENT_DIR 1)
include_directories(${PROJECT_SOURCE_DIR}/src)
include_directories(${PROJECT_BINARY_DIR})
include_directories(SYSTEM include)

include (${CMAKE_MODULE_PATH}/boost.cmake)

# -- make this work? set(python_ADDITIONAL_VERSIONS 2.7 2.6)
find_package(PythonInterp)
find_program(RAGEL ragel)

if(PYTHONINTERP_FOUND)
    set(PYTHON ${PYTHON_EXECUTABLE})
else()
    message(FATAL_ERROR "No python interpreter found")
endif()

# allow for reproducible builds - python for portability
if (DEFINED ENV{SOURCE_DATE_EPOCH})
      execute_process(
          COMMAND "${PYTHON}" "${CMAKE_MODULE_PATH}/formatdate.py" "$ENV{SOURCE_DATE_EPOCH}"
          OUTPUT_VARIABLE BUILD_DATE
          OUTPUT_STRIP_TRAILING_WHITESPACE)
else ()
    string (TIMESTAMP BUILD_DATE "%Y-%m-%d")
endif ()
message(STATUS "Build date: ${BUILD_DATE}")


if(${RAGEL} STREQUAL "RAGEL-NOTFOUND")
    message(FATAL_ERROR "Ragel state machine compiler not found")
endif()

option(DEBUG_OUTPUT "Enable debug output (warning: very verbose)" FALSE)

if(DEBUG_OUTPUT)
    add_definitions(-DDEBUG)
    set(RELEASE_BUILD FALSE)
endif(DEBUG_OUTPUT)

option(BUILD_SHARED_LIBS "Build shared libs instead of static" OFF)
option(BUILD_STATIC_AND_SHARED "Build shared libs as well as static" OFF)

if (BUILD_STATIC_AND_SHARED OR BUILD_SHARED_LIBS)
        message(STATUS "Building shared libraries")
else()
        message(STATUS "Building static libraries")
endif()

if (NOT BUILD_SHARED_LIBS)
    # build static libs
    set(BUILD_STATIC_LIBS ON)
    mark_as_advanced(BUILD_STATIC_LIBS)
endif ()

#for config
if (RELEASE_BUILD)
    set(HS_OPTIMIZE ON)
endif()

CMAKE_DEPENDENT_OPTION(DUMP_SUPPORT "Dump code support; normally on, except in release builds" ON "NOT RELEASE_BUILD" OFF)

CMAKE_DEPENDENT_OPTION(DISABLE_ASSERTS "Disable assert(); Asserts are enabled in debug builds, disabled in release builds" OFF "NOT RELEASE_BUILD" ON)

option(BUILD_AVX512 "Experimental: support avx512 in the fat runtime" OFF)

option(BUILD_AVX512VBMI "Experimental: support avx512vbmi in the fat runtime" OFF)

if (BUILD_AVX512VBMI)
    set(BUILD_AVX512 ON)
endif ()

# TODO: per platform config files?

# remove CMake's idea of optimisation
foreach (CONFIG ${CMAKE_BUILD_TYPE} ${CMAKE_CONFIGURATION_TYPES})
    string(REGEX REPLACE "-O[^ ]*" "" CMAKE_C_FLAGS_${CONFIG} "${CMAKE_C_FLAGS_${CONFIG}}")
    string(REGEX REPLACE "-O[^ ]*" "" CMAKE_CXX_FLAGS_${CONFIG} "${CMAKE_CXX_FLAGS_${CONFIG}}")
endforeach ()

if (CMAKE_C_COMPILER_ID MATCHES "Intel")
    set(SKYLAKE_FLAG "-xCORE-AVX512")
else ()
    set(SKYLAKE_FLAG "-march=skylake-avx512")
    set(ICELAKE_FLAG "-march=icelake-server")
endif ()

if(ARCH_PPC64EL)
    set(ARCH_FLAG mcpu)
else()
    set(ARCH_FLAG march)
endif()

# Detect best GNUCC_ARCH to tune for
if (CMAKE_COMPILER_IS_GNUCC AND NOT CROSS_COMPILE)
    message(STATUS "gcc version ${CMAKE_C_COMPILER_VERSION}")

    # If gcc doesn't recognise the host cpu, then mtune=native becomes
    # generic, which isn't very good in some cases. march=native looks at
    # cpuid info and then chooses the best microarch it can (and replaces
    # the flag), so use that for tune.

    # arg1 might exist if using ccache
    string (STRIP "${CMAKE_C_COMPILER_ARG1}" CC_ARG1)
    set (EXEC_ARGS ${CC_ARG1} -c -Q --help=target -${ARCH_FLAG}=native -mtune=native)
    execute_process(COMMAND ${CMAKE_C_COMPILER} ${EXEC_ARGS}
        OUTPUT_VARIABLE _GCC_OUTPUT)
    string(FIND "${_GCC_OUTPUT}" "${ARCH_FLAG}" POS)
    string(SUBSTRING "${_GCC_OUTPUT}" ${POS} -1 _GCC_OUTPUT)
    string(REGEX REPLACE "${ARCH_FLAG}=[ \t]*([^ \n]*)[ \n].*" "\\1" GNUCC_ARCH "${_GCC_OUTPUT}")

    # test the parsed flag
    set (EXEC_ARGS ${CC_ARG1} -E - -mtune=${GNUCC_ARCH})
    execute_process(COMMAND ${CMAKE_C_COMPILER} ${EXEC_ARGS}
        OUTPUT_QUIET ERROR_QUIET
        INPUT_FILE /dev/null
        RESULT_VARIABLE GNUCC_TUNE_TEST)
    if (NOT GNUCC_TUNE_TEST EQUAL 0)
        message(WARNING "Something went wrong determining gcc tune: -mtune=${GNUCC_ARCH} not valid, falling back to -mtune=native")
        set(TUNE_FLAG native)
    else()
        set(TUNE_FLAG ${GNUCC_ARCH})
        message(STATUS "gcc will tune for ${GNUCC_ARCH}, ${TUNE_FLAG}")
    endif()
elseif (CMAKE_COMPILER_IS_CLANG AND NOT CROSS_COMPILE)
    if (ARCH_IA32 OR ARCH_X86_64)
        set(GNUCC_ARCH native)
        set(TUNE_FLAG generic)
    elseif(ARCH_AARCH64)
       set(GNUCC_ARCH armv8)
       set(TUNE_FLAG generic)
    elseif(ARCH_ARM32)
       set(GNUCC_ARCH armv7a)
       set(TUNE_FLAG generic)
    else()
       set(GNUCC_ARCH native)
       set(TUNE_FLAG generic)
    endif()
    message(STATUS "clang will tune for ${GNUCC_ARCH}, ${TUNE_FLAG}")
elseif (CROSS_COMPILE)
    set(GNUCC_ARCH generic)
    set(TUNE_FLAG generic)
endif()

if (ARCH_IA32 OR ARCH_X86_64)
    if (NOT FAT_RUNTIME)
        if (BUILD_AVX512)
            set(ARCH_C_FLAGS "${SKYLAKE_FLAG}")
            set(ARCH_CXX_FLAGS "${SKYLAKE_FLAG}")
        elseif (BUILD_AVX2)
            set(ARCH_C_FLAGS "-mavx2")
            set(ARCH_CXX_FLAGS "-mavx2")
        else()
            set(ARCH_C_FLAGS "-msse4.2")
            set(ARCH_CXX_FLAGS "-msse4.2")
        endif()
    else()
       set(ARCH_C_FLAGS "-msse4.2")
       set(ARCH_CXX_FLAGS "-msse4.2")
    endif()
endif()

if (ARCH_AARCH64)
    if (BUILD_SVE2_BITPERM)
        set(GNUCC_ARCH "${GNUCC_ARCH}+sve2-bitperm")
    elseif (BUILD_SVE2)
        set(GNUCC_ARCH "${GNUCC_ARCH}+sve2")
    elseif (BUILD_SVE)
        set(GNUCC_ARCH "${GNUCC_ARCH}+sve")
    endif ()
endif(ARCH_AARCH64)


message(STATUS "ARCH_C_FLAGS   : ${ARCH_C_FLAGS}")
message(STATUS "ARCH_CXX_FLAGS : ${ARCH_CXX_FLAGS}")

if (NOT FAT_RUNTIME)
    set(ARCH_C_FLAGS "-${ARCH_FLAG}=${GNUCC_ARCH} -mtune=${TUNE_FLAG} ${ARCH_C_FLAGS}")
    set(ARCH_CXX_FLAGS "-${ARCH_FLAG}=${GNUCC_ARCH} -mtune=${TUNE_FLAG} ${ARCH_CXX_FLAGS}")
endif()

#if (ARCH_IA32 OR ARCH_X86_64 OR ARCH_ARM32 OR ARCH_AARCH64)
#    if (NOT CMAKE_C_FLAGS MATCHES .*march.* AND NOT CMAKE_C_FLAGS MATCHES .*mtune.*)
#        set(ARCH_C_FLAGS "-march=${GNUCC_ARCH} -mtune=${TUNE_FLAG}")
#    endif()
#    if (NOT CMAKE_CXX_FLAGS MATCHES .*march.* AND NOT CMAKE_CXX_FLAGS MATCHES .*mtune.*)
#        set(ARCH_CXX_FLAGS "-march=${GNUCC_ARCH} -mtune=${TUNE_FLAG}")
#    endif()
#endif()
    
#if(ARCH_PPC64EL)
#    if (NOT CMAKE_C_FLAGS MATCHES .*march.* AND NOT CMAKE_C_FLAGS MATCHES .*mtune.*)
#        set(ARCH_C_FLAGS "-mtune=${TUNE_FLAG}")
#    endif()
#    if (NOT CMAKE_CXX_FLAGS MATCHES .*march.* AND NOT CMAKE_CXX_FLAGS MATCHES .*mtune.*)
#        set(ARCH_CXX_FLAGS "-mtune=${TUNE_FLAG}")
#    endif()
#endif()

# compiler version checks TODO: test more compilers
if (CMAKE_COMPILER_IS_GNUCXX)
    set(GNUCXX_MINVER "9")
    message(STATUS "g++ version ${CMAKE_CXX_COMPILER_VERSION}")
    if (CMAKE_CXX_COMPILER_VERSION VERSION_LESS GNUCXX_MINVER)
        message(FATAL_ERROR "A minimum of g++ ${GNUCXX_MINVER} is required for C++17 support")
    endif()
endif()

if(RELEASE_BUILD)
    if (NOT CMAKE_BUILD_TYPE MATCHES MINSIZEREL)
        set(OPT_C_FLAG "-O3")
        set(OPT_CXX_FLAG "-O3")
    else ()
        set(OPT_C_FLAG "-Os")
        set(OPT_CXX_FLAG "-Os")
    endif ()
else()
    set(OPT_C_FLAG "-O0")
    set(OPT_CXX_FLAG "-O0")
endif(RELEASE_BUILD)

# set compiler flags - more are tested and added later
set(EXTRA_C_FLAGS "${OPT_C_FLAG} -std=c17 -Wall -Wextra -Wshadow -Wcast-qual -fno-strict-aliasing")
set(EXTRA_CXX_FLAGS "${OPT_CXX_FLAG} -std=c++17 -Wall -Wextra -Wshadow -Wswitch -Wreturn-type -Wcast-qual -Wno-deprecated -Wnon-virtual-dtor -fno-strict-aliasing")
if (NOT CMAKE_COMPILER_IS_CLANG)
    set(EXTRA_CXX_FLAGS "${EXTRA_CXX_FLAGS} -fno-new-ttp-matching")
endif()

if (NOT RELEASE_BUILD)
    # -Werror is most useful during development, don't potentially break
    # release builds
    set(EXTRA_C_FLAGS "${EXTRA_C_FLAGS} -Werror")
    set(EXTRA_CXX_FLAGS "${EXTRA_CXX_FLAGS} -Werror")
endif()

if (DISABLE_ASSERTS)
    set(EXTRA_C_FLAGS "${EXTRA_C_FLAGS} -DNDEBUG")
    set(EXTRA_CXX_FLAGS "${EXTRA_CXX_FLAGS} -DNDEBUG")
endif()

if(CMAKE_COMPILER_IS_GNUCC)
    # spurious warnings?
    set(EXTRA_C_FLAGS "${EXTRA_C_FLAGS} -Wno-array-bounds -Wno-maybe-uninitialized")
endif()

if(CMAKE_COMPILER_IS_GNUCXX)
    set(EXTRA_CXX_FLAGS "${EXTRA_CXX_FLAGS} -Wno-maybe-uninitialized")
    if (CMAKE_CXX_COMPILER_VERSION VERSION_LESS 5.0)
        set(EXTRA_CXX_FLAGS "${EXTRA_CXX_FLAGS} -fabi-version=0")
    endif ()
    # don't complain about abi
    set(EXTRA_C_FLAGS "${EXTRA_C_FLAGS} -Wno-abi")
    set(EXTRA_CXX_FLAGS "${EXTRA_CXX_FLAGS} -Wno-abi")
endif()

if (NOT(ARCH_IA32 AND RELEASE_BUILD))
    set(EXTRA_C_FLAGS "${EXTRA_C_FLAGS} -fno-omit-frame-pointer")
    set(EXTRA_CXX_FLAGS "${EXTRA_CXX_FLAGS} -fno-omit-frame-pointer")
endif()

CHECK_INCLUDE_FILES(unistd.h HAVE_UNISTD_H)
if (ARCH_IA32 OR ARCH_X86_64)
  CHECK_INCLUDE_FILES(intrin.h HAVE_C_INTRIN_H)
  CHECK_INCLUDE_FILE_CXX(intrin.h HAVE_CXX_INTRIN_H)
  CHECK_INCLUDE_FILES(x86intrin.h HAVE_C_X86INTRIN_H)
  CHECK_INCLUDE_FILE_CXX(x86intrin.h HAVE_CXX_X86INTRIN_H)
elseif (ARCH_ARM32 OR ARCH_AARCH64)
  CHECK_INCLUDE_FILE_CXX(arm_neon.h HAVE_C_ARM_NEON_H)
  if (BUILD_SVE OR BUILD_SVE2 OR BUILD_SVE2_BITPERM)
    CHECK_INCLUDE_FILE_CXX(arm_sve.h HAVE_C_ARM_SVE_H)
    if (NOT HAVE_C_ARM_SVE_H)
      message(FATAL_ERROR "arm_sve.h is required to build for SVE.")
    endif()
  endif()
elseif (ARCH_PPC64EL)
  CHECK_INCLUDE_FILE_CXX(altivec.h HAVE_C_PPC64EL_ALTIVEC_H)
endif()

CHECK_FUNCTION_EXISTS(posix_memalign HAVE_POSIX_MEMALIGN)
CHECK_FUNCTION_EXISTS(_aligned_malloc HAVE__ALIGNED_MALLOC)

# these end up in the config file
CHECK_C_COMPILER_FLAG(-fvisibility=hidden HAS_C_HIDDEN)
CHECK_CXX_COMPILER_FLAG(-fvisibility=hidden HAS_CXX_HIDDEN)

# are we using libc++
CHECK_CXX_SYMBOL_EXISTS(_LIBCPP_VERSION ciso646 HAVE_LIBCPP)

if (RELEASE_BUILD)
    if (HAS_C_HIDDEN)

=== unit/CMakeLists.txt ===
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${EXTRA_C_FLAGS}")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${EXTRA_CXX_FLAGS}")

set(gtest_SOURCES gtest/gtest-all.cc gtest/gtest.h)
include_directories(SYSTEM ${CMAKE_CURRENT_SOURCE_DIR})
include_directories(${PROJECT_SOURCE_DIR})

# remove some warnings
# cmake's scope means these only apply here

if (CXX_MISSING_DECLARATIONS)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-missing-declarations")
endif()

if(CXX_WEAK_VTABLES)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-weak-vtables")
endif()

if(CXX_WUNUSED_VARIABLE)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-unused-variable")
endif()

if (CXX_UNUSED_LOCAL_TYPEDEFS)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-unused-local-typedefs")
endif()

if(CMAKE_COMPILER_IS_GNUCC)
    # spurious warnings?
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-array-bounds")
endif()

add_definitions(-DGTEST_HAS_PTHREAD=0 -DSRCDIR=${PROJECT_SOURCE_DIR})

set(unit_hyperscan_SOURCES
    ${gtest_SOURCES}
    hyperscan/allocators.cpp
    hyperscan/arg_checks.cpp
    hyperscan/bad_patterns.cpp
    hyperscan/bad_patterns.txt
    hyperscan/behaviour.cpp
    hyperscan/expr_info.cpp
    hyperscan/extparam.cpp
    hyperscan/identical.cpp
    hyperscan/literals.cpp
    hyperscan/logical_combination.cpp
    hyperscan/main.cpp
    hyperscan/multi.cpp
    hyperscan/order.cpp
    hyperscan/scratch_op.cpp
    hyperscan/scratch_in_use.cpp
    hyperscan/serialize.cpp
    hyperscan/single.cpp
    hyperscan/som.cpp
    hyperscan/stream_op.cpp
    hyperscan/test_util.cpp
    hyperscan/test_util.h
    )
add_executable(unit-hyperscan ${unit_hyperscan_SOURCES})
if (BUILD_STATIC_AND_SHARED OR BUILD_SHARED_LIBS)
target_link_libraries(unit-hyperscan hs_shared expressionutil)
else()
target_link_libraries(unit-hyperscan hs expressionutil)
endif()


if (NOT FAT_RUNTIME )
set(unit_internal_SOURCES
    ${gtest_SOURCES}
    internal/bitfield.cpp
    internal/bitutils.cpp
    internal/charreach.cpp
    internal/compare.cpp
    internal/database.cpp
    internal/depth.cpp
    internal/fdr_loadval.cpp
    internal/flat_set.cpp
    internal/flat_map.cpp
    internal/graph.cpp
    internal/graph_undirected.cpp
    internal/insertion_ordered.cpp
    internal/lbr.cpp
    internal/multi_bit.cpp
    internal/multi_bit_compress.cpp
    internal/nfagraph_common.h
    internal/nfagraph_comp.cpp
    internal/nfagraph_equivalence.cpp
    internal/nfagraph_find_matches.cpp
    internal/nfagraph_literal_analysis.cpp
    internal/nfagraph_redundancy.cpp
    internal/nfagraph_repeat.cpp
    internal/nfagraph_util.cpp
    internal/nfagraph_width.cpp
    internal/noodle.cpp
    internal/pack_bits.cpp
    internal/parser.cpp
    internal/partial.cpp
    internal/pqueue.cpp
    internal/repeat.cpp
    internal/rose_build_merge.cpp
    internal/rose_mask.cpp
    internal/rose_mask_32.cpp
    internal/rvermicelli.cpp
    internal/simd_utils.cpp
    internal/supervector.cpp
    internal/shuffle.cpp
    internal/shufti.cpp
    internal/state_compress.cpp
    internal/truffle.cpp
    internal/unaligned.cpp
    internal/unicode_set.cpp
    internal/uniform_ops.cpp
    internal/utf8_validate.cpp
    internal/util_string.cpp
    internal/vermicelli.cpp
    internal/main.cpp
    )
if (BUILD_AVX2)
set(unit_internal_SOURCES
    ${unit_internal_SOURCES}
    internal/masked_move.cpp
    )
endif(BUILD_AVX2)

if (NOT RELEASE_BUILD)
set(unit_internal_SOURCES
    ${unit_internal_SOURCES}    
    internal/fdr.cpp
    internal/fdr_flood.cpp
    internal/limex_nfa.cpp
   )	
endif(NOT RELEASE_BUILD)

add_executable(unit-internal ${unit_internal_SOURCES})
set_target_properties(unit-internal PROPERTIES COMPILE_FLAGS "${HS_CXX_FLAGS}")
target_link_libraries(unit-internal hs corpusomatic)
endif(NOT FAT_RUNTIME)

if (BUILD_CHIMERA)
    # enable Chimera unit tests
    set(unit_chimera_SOURCES
        ${gtest_SOURCES}
        chimera/allocators.cpp
        chimera/arg_checks.cpp
        chimera/bad_patterns.cpp
        chimera/compat.cpp
        chimera/main.cpp
        chimera/scan.cpp
        )
    add_executable(unit-chimera ${unit_chimera_SOURCES})
    target_link_libraries(unit-chimera chimera hs pcre)
    #
    # build target to run unit tests
    #
    if (NOT RELEASE_BUILD)
    add_custom_target(
        unit
        COMMAND bin/unit-internal
        COMMAND bin/unit-hyperscan
        COMMAND bin/unit-chimera
        WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
        DEPENDS unit-internal unit-hyperscan unit-chimera
    )
    else ()
    add_custom_target(
        unit
        COMMAND bin/unit-hyperscan
        COMMAND bin/unit-chimera
        WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
        DEPENDS unit-hyperscan unit-chimera
    )
    endif()
else()
    #
    # build target to run unit tests
    #
    if (NOT RELEASE_BUILD)
    add_custom_target(
        unit
        COMMAND bin/unit-internal
        COMMAND bin/unit-hyperscan
        WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
        DEPENDS unit-internal unit-hyperscan
    )
    else ()
    add_custom_target(
        unit
        COMMAND bin/unit-internal
        COMMAND bin/unit-hyperscan
        WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
        DEPENDS unit-internal unit-hyperscan
    )
    endif()
endif()

=== tools/hscheck/CMakeLists.txt ===
# only set these after all tests are done
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${EXTRA_C_FLAGS}")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${EXTRA_CXX_FLAGS}")

SET(hscheck_SOURCES
    main.cpp
)

if (BUILD_CHIMERA)
    include_directories(${PCRE_INCLUDE_DIRS})
    add_definitions(-DHS_HYBRID)
    add_executable(hscheck ${hscheck_SOURCES})
    target_link_libraries(hscheck hs chimera ${PCRE_LDFLAGS} expressionutil pthread)
else()
    add_executable(hscheck ${hscheck_SOURCES})
    target_link_libraries(hscheck hs expressionutil pthread)
endif()

=== tools/hscollider/CMakeLists.txt ===
if (NOT CORRECT_PCRE_VERSION)
    message(STATUS "PCRE ${PCRE_REQUIRED_VERSION} not found, not building hscollider")
    return()
endif()

include_directories(${PCRE_INCLUDE_DIRS})

include(${CMAKE_MODULE_PATH}/backtrace.cmake)

# we need static libs - too much deep magic for shared libs
if (NOT BUILD_STATIC_LIBS)
    return ()
endif ()

CHECK_FUNCTION_EXISTS(sigaltstack HAVE_SIGALTSTACK)
CHECK_FUNCTION_EXISTS(sigaction HAVE_SIGACTION)
CHECK_FUNCTION_EXISTS(setrlimit HAVE_SETRLIMIT)

set_source_files_properties(
    ${CMAKE_CURRENT_BINARY_DIR}/ColliderCorporaParser.cpp
    PROPERTIES
    COMPILE_FLAGS "${RAGEL_C_FLAGS} -I${CMAKE_CURRENT_SOURCE_DIR}")

ragelmaker(ColliderCorporaParser.rl)

if (BUILD_CHIMERA)
    add_definitions(-DHS_HYBRID)
endif()

# only set these after all tests are done
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${EXTRA_C_FLAGS}")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${EXTRA_CXX_FLAGS}")

SET(hscollider_SOURCES
    common.h
    BoundedQueue.h
    Corpora.cpp
    FileCorpora.h
    FileCorpora.cpp
    ColliderCorporaParser.h
    ColliderCorporaParser.cpp
    NfaGeneratedCorpora.h
    NfaGeneratedCorpora.cpp
    GraphTruth.h
    GraphTruth.cpp
    GroundTruth.h
    GroundTruth.cpp
    UltimateTruth.h
    UltimateTruth.cpp
    ResultSet.h
    args.cpp
    args.h
    limit.cpp
    pcre_util.cpp
    sig.cpp
    sig.h
    DatabaseProxy.h
    Thread.h
    Thread.cpp
    main.cpp
)

set_source_files_properties(${hscollider_SOURCES} PROPERTIES
    INCLUDE_DIRECTORIES ${CMAKE_CURRENT_SOURCE_DIR})
add_executable(hscollider ${hscollider_SOURCES})
add_dependencies(hscollider ragel_ColliderCorporaParser)

if (BUILD_CHIMERA)
    target_link_libraries(hscollider hs chimera ${PCRE_LDFLAGS} databaseutil
        expressionutil corpusomatic crosscompileutil pthread
    "${BACKTRACE_LDFLAGS}")
else()
    target_link_libraries(hscollider hs ${PCRE_LDFLAGS} databaseutil
        expressionutil corpusomatic crosscompileutil pthread
    "${BACKTRACE_LDFLAGS}")
endif()

if(HAVE_BACKTRACE)
    set_source_files_properties(hscollider_SOURCES COMPILE_FLAGS
        "${BACKTRACE_CFLAGS}")
endif()

add_custom_target(
    collide_quick_test
    COMMAND ${CMAKE_BINARY_DIR}/bin/hscollider
        -s ${CMAKE_SOURCE_DIR}/tools/hscollider/test_cases/signatures/collider_tests.txt
        -c ${CMAKE_SOURCE_DIR}/tools/hscollider/test_cases/corpora/*
        -Z0 -t3
    DEPENDS hscollider
)

add_custom_target(
    collide_quick_test_block
    COMMAND ${CMAKE_BINARY_DIR}/bin/hscollider
        -s ${CMAKE_SOURCE_DIR}/tools/hscollider/test_cases/signatures/collider_tests.txt
        -c ${CMAKE_SOURCE_DIR}/tools/hscollider/test_cases/corpora/*
        -Z0
    DEPENDS hscollider
)

=== debian/changelog ===
vectorscan (5.4.6-2) unstable; urgency=medium

  * Fix wrong VCS entries in control, Standards version,
    add Multi-Arch: same to binary package.

 -- Konstantinos Margaritis <markos@debian.org>  Wed, 26 Jan 2022 14:57:36 +0200

vectorscan (5.4.6-1) unstable; urgency=medium

  * Initial release. (Closes: #1004079)

 -- Konstantinos Margaritis <markos@debian.org>  Wed, 15 Dec 2021 13:20:38 +0200

=== debian/control ===
Source: vectorscan
Priority: optional
Maintainer: Konstantinos Margaritis <markos@debian.org>
Build-Depends: cmake (>=2.8.11),
               debhelper-compat (=12),
               libboost-dev (>=1.57),
               libpcap-dev,
               pkg-config,
               po-debconf,
               python3,
               ragel (>=6.9)
Standards-Version: 4.6.0
Section: libs
Rules-Requires-Root: no
Homepage: https://vectorcamp.gr/vectorscan
Vcs-Git: https://github.com/VectorCamp/vectorscan.git
Vcs-Browser: https://github.com/VectorCamp/vectorscan

Package: libvectorscan-dev
Section: libdevel
Architecture: any-amd64 arm64 ppc64el
Replaces: libhyperscan-dev
Conflicts: libhyperscan-dev
Provides: libhyperscan-dev
Depends: libvectorscan5 (= ${binary:Version}), ${misc:Depends}
Description: Portable fork of Intel's Hyperscan library (development files)
 Vectorscan is a portable fork of Intel's Hyperscan project. It is a drop-in
 replacement that promises to be API/ABI compatible with the original project,
 while allowing it to run on other architectures such as AArch64 and Power9.
 .
 This package contains development libraries, header files and documentation for
 the regular expression matching library libhyperscan. You can either use the
 supplied shared or static library.
 .
 Vectorscan only runs on CPUs with a SIMD unit. On x86 CPUs, the minimum
 requirement is SSE4.2, AArch64 ISA already implies Advanced SIMD/NEON and
 ppc64le (Power8/Power9) already implies VSX enabled by default.

Package: libvectorscan5
Architecture: any-amd64 arm64 ppc64el
Depends: ${misc:Depends}, ${shlibs:Depends}, sse4.2-support [any-amd64]
Multi-Arch: same
Pre-Depends: debconf
Replaces: libhyperscan5
Conflicts: libhyperscan5
Provides: libhyperscan5
Description: Portable fork of Intel's Hyperscan library
 Vectorscan is a portable fork of Intel's Hyperscan project. It is a drop-in
 replacement that promises to be API/ABI compatible with the original project,
 while allowing it to run on other architectures such as AArch64 and Power9.
 .
 Hyperscan is a high-performance multiple regex matching library.
 It follows the regular expression syntax of the commonly-used libpcre library,
 but is a standalone library with its own C API. Hyperscan uses hybrid automata
 techniques to allow simultaneous matching of large numbers (up to tens of
 thousands) of regular expressions and for the matching of regular expressions
 across streams of data. Hyperscan is typically used in a DPI library stack.
 .
 Vectorscan only runs on CPUs with a SIMD unit. On x86 CPUs, the minimum
 requirement is SSE4.2, AArch64 ISA already implies Advanced SIMD/NEON and
 ppc64le (Power8/Power9) already implies VSX enabled by default.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

ifeq ($(DEB_HOST_ARCH),amd64)
export DEB_CMAKE_FLAGS = -DBUILD_AVX2=on -DBUILD_AVX512=on -DBUILD_AVX512VBMI=off -DFAT_RUNTIME=on
endif

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
		-DBUILD_STATIC_AND_SHARED=1 \
		-DCMAKE_BUILD_TYPE=RelWithDebInfo \
		${DEB_CMAKE_FLAGS}

override_dh_missing:
	dh_missing --fail-missing

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%<project>-$1.tar.gz%" \
    https://github.com/vectorcamp/vectorscan/releases \
    (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate

## vectorscan 5.4.7

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,7 +3,7 @@
 
 set (HS_MAJOR_VERSION 5)
 set (HS_MINOR_VERSION 4)
-set (HS_PATCH_VERSION 6)
+set (HS_PATCH_VERSION 7)
 set (HS_VERSION ${HS_MAJOR_VERSION}.${HS_MINOR_VERSION}.${HS_PATCH_VERSION})
 
 set(CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake)
@@ -123,6 +123,8 @@
 if (RELEASE_BUILD)
     set(HS_OPTIMIZE ON)
 endif()
+
+include (${CMAKE_MODULE_PATH}/sanitize.cmake)
 
 CMAKE_DEPENDENT_OPTION(DUMP_SUPPORT "Dump code support; normally on, except in release builds" ON "NOT RELEASE_BUILD" OFF)
 
@@ -352,5 +354,3 @@
 # are we using libc++
 CHECK_CXX_SYMBOL_EXISTS(_LIBCPP_VERSION ciso646 HAVE_LIBCPP)
 
-if (RELEASE_BUILD)
-    if (HAS_C_HIDDEN)

=== debian/changelog ===
vectorscan (5.4.7-1ubuntu1) kinetic; urgency=medium

  * debian/patches/missing-c++-include.patch: add missing C++ include.
    Thanks to Steve Langasek <steve.langasek@ubuntu.com>.
  * rebuild to fix segfault in kbtin on ppc64el.

 -- Steve Langasek <vorlon@debian.org>  Sat, 10 Sep 2022 00:13:15 +0000

vectorscan (5.4.7-1) unstable; urgency=medium

  * New upstream release.

 -- Konstantinos Margaritis <markos@debian.org>  Thu, 05 May 2022 12:29:34 +0300

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,7 @@
 Source: vectorscan
 Priority: optional
-Maintainer: Konstantinos Margaritis <markos@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Konstantinos Margaritis <markos@debian.org>
 Build-Depends: cmake (>=2.8.11),
                debhelper-compat (=12),
                libboost-dev (>=1.57),
@@ -19,6 +20,7 @@
 Package: libvectorscan-dev
 Section: libdevel
 Architecture: any-amd64 arm64 ppc64el
+Multi-Arch: same
 Replaces: libhyperscan-dev
 Conflicts: libhyperscan-dev
 Provides: libhyperscan-dev

## vectorscan 5.4.8

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,7 +3,7 @@
 
 set (HS_MAJOR_VERSION 5)
 set (HS_MINOR_VERSION 4)
-set (HS_PATCH_VERSION 7)
+set (HS_PATCH_VERSION 8)
 set (HS_VERSION ${HS_MAJOR_VERSION}.${HS_MINOR_VERSION}.${HS_PATCH_VERSION})
 
 set(CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake)
@@ -71,13 +71,10 @@
 
 include (${CMAKE_MODULE_PATH}/boost.cmake)
 
-# -- make this work? set(python_ADDITIONAL_VERSIONS 2.7 2.6)
-find_package(PythonInterp)
+find_package(Python COMPONENTS Interpreter)
 find_program(RAGEL ragel)
 
-if(PYTHONINTERP_FOUND)
-    set(PYTHON ${PYTHON_EXECUTABLE})
-else()
+if(NOT Python_Interpreter_FOUND)
     message(FATAL_ERROR "No python interpreter found")
 endif()
 
@@ -354,3 +351,5 @@
 # are we using libc++
 CHECK_CXX_SYMBOL_EXISTS(_LIBCPP_VERSION ciso646 HAVE_LIBCPP)
 
+if (RELEASE_BUILD)
+    if (HAS_C_HIDDEN)

=== debian/changelog ===
vectorscan (5.4.8-2) unstable; urgency=medium

  * Remove constraints unnecessary since buster (oldstable):
    + Build-Depends: Drop versioned constraint on cmake, libboost-dev and ragel.

 -- Debian Janitor <janitor@jelmer.uk>  Wed, 14 Sep 2022 20:07:36 -0000

vectorscan (5.4.8-1) unstable; urgency=medium

  * New upstream release 

 -- Konstantinos Margaritis <markos@debian.org>  Tue, 13 Sep 2022 16:38:56 +0300

=== debian/control ===
--- 
+++ 
@@ -1,16 +1,15 @@
 Source: vectorscan
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Konstantinos Margaritis <markos@debian.org>
-Build-Depends: cmake (>=2.8.11),
-               debhelper-compat (=12),
-               libboost-dev (>=1.57),
+Maintainer: Konstantinos Margaritis <markos@debian.org>
+Build-Depends: cmake,
+               debhelper-compat (= 12),
+               libboost-dev,
                libpcap-dev,
                pkg-config,
                po-debconf,
                python3,
-               ragel (>=6.9)
-Standards-Version: 4.6.0
+               ragel
+Standards-Version: 4.6.1
 Section: libs
 Rules-Requires-Root: no
 Homepage: https://vectorcamp.gr/vectorscan

## vectorscan 5.4.9

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,9 +1,10 @@
-cmake_minimum_required (VERSION 2.8.11)
+cmake_minimum_required (VERSION 2.8.12)
+
 project (vectorscan C CXX)
 
 set (HS_MAJOR_VERSION 5)
 set (HS_MINOR_VERSION 4)
-set (HS_PATCH_VERSION 8)
+set (HS_PATCH_VERSION 9)
 set (HS_VERSION ${HS_MAJOR_VERSION}.${HS_MINOR_VERSION}.${HS_PATCH_VERSION})
 
 set(CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake)
@@ -165,27 +166,49 @@
     # cpuid info and then chooses the best microarch it can (and replaces
     # the flag), so use that for tune.
 
+    set(TUNE_FLAG "mtune")
+    set(GNUCC_TUNE "")
+    message(STATUS "ARCH_FLAG '${ARCH_FLAG}' '${GNUCC_ARCH}', TUNE_FLAG '${TUNE_FLAG}' '${GNUCC_TUNE}' ")
+
     # arg1 might exist if using ccache
     string (STRIP "${CMAKE_C_COMPILER_ARG1}" CC_ARG1)
-    set (EXEC_ARGS ${CC_ARG1} -c -Q --help=target -${ARCH_FLAG}=native -mtune=native)
+    set (EXEC_ARGS ${CC_ARG1} -c -Q --help=target -${ARCH_FLAG}=native -${TUNE_FLAG}=native)
     execute_process(COMMAND ${CMAKE_C_COMPILER} ${EXEC_ARGS}
         OUTPUT_VARIABLE _GCC_OUTPUT)
-    string(FIND "${_GCC_OUTPUT}" "${ARCH_FLAG}" POS)
+    set(_GCC_OUTPUT_TUNE ${_GCC_OUTPUT})
+    string(FIND "${_GCC_OUTPUT}" "${ARCH_FLAG}=" POS)
     string(SUBSTRING "${_GCC_OUTPUT}" ${POS} -1 _GCC_OUTPUT)
     string(REGEX REPLACE "${ARCH_FLAG}=[ \t]*([^ \n]*)[ \n].*" "\\1" GNUCC_ARCH "${_GCC_OUTPUT}")
 
+    string(FIND "${_GCC_OUTPUT_TUNE}" "${TUNE_FLAG}=" POS_TUNE)
+    string(SUBSTRING "${_GCC_OUTPUT_TUNE}" ${POS_TUNE} -1 _GCC_OUTPUT_TUNE)
+    string(REGEX REPLACE "${TUNE_FLAG}=[ \t]*([^ \n]*)[ \n].*" "\\1" GNUCC_TUNE "${_GCC_OUTPUT_TUNE}")
+
+    string(FIND "${GNUCC_ARCH}" "sve" POS_SVE)
+    string(FIND "${GNUCC_ARCH}" "sve2" POS_SVE2)
+    string(FIND "${GNUCC_ARCH}" "sve2-bitperm" POS_SVE2_BITPERM)
+    if (NOT POS_SVE EQUAL 0)
+        set(SVE_FOUND 1)
+    elseif(NOT POS_SVE2 EQUAL 0)
+        set(SVE2_FOUND 1)
+    elseif(NOT POS_SVE2_BITPERM EQUAL 0)
+        set(SVE2_BITPERM_FOUND 1)
+    endif()
+
+    message(STATUS "ARCH_FLAG '${ARCH_FLAG}' '${GNUCC_ARCH}', TUNE_FLAG '${TUNE_FLAG}' '${GNUCC_TUNE}' ")
+
     # test the parsed flag
-    set (EXEC_ARGS ${CC_ARG1} -E - -mtune=${GNUCC_ARCH})
+    set (EXEC_ARGS ${CC_ARG1} -E - -${ARCH_FLAG}=${GNUCC_ARCH} -${TUNE_FLAG}=${GNUCC_TUNE})
     execute_process(COMMAND ${CMAKE_C_COMPILER} ${EXEC_ARGS}
         OUTPUT_QUIET ERROR_QUIET
         INPUT_FILE /dev/null
         RESULT_VARIABLE GNUCC_TUNE_TEST)
     if (NOT GNUCC_TUNE_TEST EQUAL 0)
-        message(WARNING "Something went wrong determining gcc tune: -mtune=${GNUCC_ARCH} not valid, falling back to -mtune=native")
-        set(TUNE_FLAG native)
+        message(WARNING "Something went wrong determining gcc tune: -mtune=${GNUCC_TUNE} not valid, falling back to -mtune=native")
+        set(GNUCC_TUNE native)
     else()
-        set(TUNE_FLAG ${GNUCC_ARCH})
-        message(STATUS "gcc will tune for ${GNUCC_ARCH}, ${TUNE_FLAG}")
+        set(GNUCC_TUNE ${GNUCC_TUNE})
+        message(STATUS "gcc will tune for ${GNUCC_ARCH}, ${GNUCC_TUNE}")
     endif()
 elseif (CMAKE_COMPILER_IS_CLANG AND NOT CROSS_COMPILE)
     if (ARCH_IA32 OR ARCH_X86_64)
@@ -226,22 +249,26 @@
 endif()
 
 if (ARCH_AARCH64)
-    if (BUILD_SVE2_BITPERM)
+    if (BUILD_SVE2_BITPERM AND NOT SVE2_BITPERM_FOUND)
         set(GNUCC_ARCH "${GNUCC_ARCH}+sve2-bitperm")
-    elseif (BUILD_SVE2)
+    elseif (BUILD_SVE2 AND NOT SVE2_FOUND)
         set(GNUCC_ARCH "${GNUCC_ARCH}+sve2")
-    elseif (BUILD_SVE)
+    elseif (BUILD_SVE AND NOT SVE_FOUND)
         set(GNUCC_ARCH "${GNUCC_ARCH}+sve")
     endif ()
 endif(ARCH_AARCH64)
 
-
 message(STATUS "ARCH_C_FLAGS   : ${ARCH_C_FLAGS}")
 message(STATUS "ARCH_CXX_FLAGS : ${ARCH_CXX_FLAGS}")
 
 if (NOT FAT_RUNTIME)
-    set(ARCH_C_FLAGS "-${ARCH_FLAG}=${GNUCC_ARCH} -mtune=${TUNE_FLAG} ${ARCH_C_FLAGS}")
-    set(ARCH_CXX_FLAGS "-${ARCH_FLAG}=${GNUCC_ARCH} -mtune=${TUNE_FLAG} ${ARCH_CXX_FLAGS}")
+    if (GNUCC_TUNE)
+        set(ARCH_C_FLAGS "-${ARCH_FLAG}=${GNUCC_ARCH} -${TUNE_FLAG}=${GNUCC_TUNE}")
+        set(ARCH_CXX_FLAGS "-${ARCH_FLAG}=${GNUCC_ARCH} -${TUNE_FLAG}=${GNUCC_TUNE}")
+    else()
+        set(ARCH_C_FLAGS "-${ARCH_FLAG}=${GNUCC_ARCH} -mtune=${TUNE_FLAG} ${ARCH_C_FLAGS}")
+        set(ARCH_CXX_FLAGS "-${ARCH_FLAG}=${GNUCC_ARCH} -mtune=${TUNE_FLAG} ${ARCH_CXX_FLAGS}")
+    endif()
 endif()
 
 #if (ARCH_IA32 OR ARCH_X86_64 OR ARCH_ARM32 OR ARCH_AARCH64)
@@ -296,6 +323,12 @@
     # release builds
     set(EXTRA_C_FLAGS "${EXTRA_C_FLAGS} -Werror")
     set(EXTRA_CXX_FLAGS "${EXTRA_CXX_FLAGS} -Werror")
+    if (CMAKE_COMPILER_IS_CLANG)
+	if (CMAKE_C_COMPILER_VERSION VERSION_GREATER "13.0")
+           set(EXTRA_C_FLAGS "${EXTRA_C_FLAGS} -Wno-unused-but-set-variable")
+           set(EXTRA_CXX_FLAGS "${EXTRA_CXX_FLAGS} -Wno-unused-but-set-variable")
+        endif()
+    endif()
 endif()
 
 if (DISABLE_ASSERTS)
@@ -311,45 +344,3 @@
 if(CMAKE_COMPILER_IS_GNUCXX)
     set(EXTRA_CXX_FLAGS "${EXTRA_CXX_FLAGS} -Wno-maybe-uninitialized")
     if (CMAKE_CXX_COMPILER_VERSION VERSION_LESS 5.0)
-        set(EXTRA_CXX_FLAGS "${EXTRA_CXX_FLAGS} -fabi-version=0")
-    endif ()
-    # don't complain about abi
-    set(EXTRA_C_FLAGS "${EXTRA_C_FLAGS} -Wno-abi")
-    set(EXTRA_CXX_FLAGS "${EXTRA_CXX_FLAGS} -Wno-abi")
-endif()
-
-if (NOT(ARCH_IA32 AND RELEASE_BUILD))
-    set(EXTRA_C_FLAGS "${EXTRA_C_FLAGS} -fno-omit-frame-pointer")
-    set(EXTRA_CXX_FLAGS "${EXTRA_CXX_FLAGS} -fno-omit-frame-pointer")
-endif()
-
-CHECK_INCLUDE_FILES(unistd.h HAVE_UNISTD_H)
-if (ARCH_IA32 OR ARCH_X86_64)
-  CHECK_INCLUDE_FILES(intrin.h HAVE_C_INTRIN_H)
-  CHECK_INCLUDE_FILE_CXX(intrin.h HAVE_CXX_INTRIN_H)
-  CHECK_INCLUDE_FILES(x86intrin.h HAVE_C_X86INTRIN_H)
-  CHECK_INCLUDE_FILE_CXX(x86intrin.h HAVE_CXX_X86INTRIN_H)
-elseif (ARCH_ARM32 OR ARCH_AARCH64)
-  CHECK_INCLUDE_FILE_CXX(arm_neon.h HAVE_C_ARM_NEON_H)
-  if (BUILD_SVE OR BUILD_SVE2 OR BUILD_SVE2_BITPERM)
-    CHECK_INCLUDE_FILE_CXX(arm_sve.h HAVE_C_ARM_SVE_H)
-    if (NOT HAVE_C_ARM_SVE_H)
-      message(FATAL_ERROR "arm_sve.h is required to build for SVE.")
-    endif()
-  endif()
-elseif (ARCH_PPC64EL)
-  CHECK_INCLUDE_FILE_CXX(altivec.h HAVE_C_PPC64EL_ALTIVEC_H)
-endif()
-
-CHECK_FUNCTION_EXISTS(posix_memalign HAVE_POSIX_MEMALIGN)
-CHECK_FUNCTION_EXISTS(_aligned_malloc HAVE__ALIGNED_MALLOC)
-
-# these end up in the config file
-CHECK_C_COMPILER_FLAG(-fvisibility=hidden HAS_C_HIDDEN)
-CHECK_CXX_COMPILER_FLAG(-fvisibility=hidden HAS_CXX_HIDDEN)
-
-# are we using libc++
-CHECK_CXX_SYMBOL_EXISTS(_LIBCPP_VERSION ciso646 HAVE_LIBCPP)
-
-if (RELEASE_BUILD)
-    if (HAS_C_HIDDEN)

=== chimera/CMakeLists.txt ===
# Chimera lib

include_directories(${PCRE_INCLUDE_DIRS})

# only set these after all tests are done
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${EXTRA_C_FLAGS}")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${EXTRA_CXX_FLAGS}")

SET(chimera_HEADERS
    ch.h
    ch_common.h
    ch_compile.h
    ch_runtime.h
)
install(FILES ${chimera_HEADERS} DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/hs")

SET(chimera_SRCS
    ${chimera_HEADERS}
    ch_alloc.c
    ch_alloc.h
    ch_compile.cpp
    ch_database.c
    ch_database.h
    ch_internal.h
    ch_runtime.c
    ch_scratch.h
    ch_scratch.c
)

add_library(chimera STATIC ${chimera_SRCS})
add_dependencies(chimera hs pcre)
target_link_libraries(chimera hs pcre)

install(TARGETS chimera DESTINATION ${CMAKE_INSTALL_LIBDIR})

# expand out library names for pkgconfig static link info
foreach (LIB ${CMAKE_CXX_IMPLICIT_LINK_LIBRARIES})
    # this is fragile, but protects us from toolchain specific files
    if (NOT EXISTS ${LIB})
        set(PRIVATE_LIBS "${PRIVATE_LIBS} -l${LIB}")
    endif()
endforeach()
set(PRIVATE_LIBS "${PRIVATE_LIBS} -L${LIBDIR} -lpcre")

configure_file(libch.pc.in libch.pc @ONLY) # only replace @ quoted vars
install(FILES ${CMAKE_BINARY_DIR}/chimera/libch.pc
    DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig")

=== examples/CMakeLists.txt ===
find_library(PCAP_LIBRARY pcap)

if (NOT PCAP_LIBRARY)
    message(STATUS "Could not find libpcap - some examples will not be built")
endif()

add_executable(simplegrep simplegrep.c)
set_source_files_properties(simplegrep.c PROPERTIES COMPILE_FLAGS
    "-Wall -Wno-unused-parameter")
target_link_libraries(simplegrep hs)

if (PCAP_LIBRARY)
add_executable(pcapscan pcapscan.cc)
set_source_files_properties(pcapscan.cc PROPERTIES COMPILE_FLAGS
    "-Wall -Wno-unused-parameter")
target_link_libraries(pcapscan hs pcap)
endif()

if (PCAP_LIBRARY)
add_executable(patbench patbench.cc)
set_source_files_properties(patbench.cc PROPERTIES COMPILE_FLAGS
    "-Wall -Wno-unused-parameter")
target_link_libraries(patbench hs pcap)
endif()

install(FILES simplegrep.c pcapscan.cc patbench.cc README.md
        DESTINATION ${CMAKE_INSTALL_DOCDIR}/examples)

=== util/CMakeLists.txt ===
# utility libs

CHECK_FUNCTION_EXISTS(mmap HAVE_MMAP)

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${EXTRA_CXX_FLAGS} ${HS_CXX_FLAGS}")
include_directories(${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR}
    ${PROJECT_SOURCE_DIR})

message("RAGEL_C_FLAGS" ${RAGEL_C_FLAGS})

set_source_files_properties(
    ${CMAKE_BINARY_DIR}/util/ExpressionParser.cpp
    PROPERTIES
    COMPILE_FLAGS "${RAGEL_C_FLAGS}")

ragelmaker(ExpressionParser.rl)

set(expressionutil_SRCS
    expressions.cpp
    expressions.h
    ExpressionParser.h
    ExpressionParser.cpp
    )
add_library(expressionutil STATIC ${expressionutil_SRCS})
add_dependencies(expressionutil ragel_ExpressionParser)

SET(corpusomatic_SRCS
    ng_corpus_editor.h
    ng_corpus_editor.cpp
    ng_corpus_generator.h
    ng_corpus_generator.cpp
    ng_corpus_properties.h
    ng_corpus_properties.cpp
    ng_find_matches.h
    ng_find_matches.cpp
)
add_library(corpusomatic STATIC ${corpusomatic_SRCS})

set(databaseutil_SRCS
    database_util.cpp
    database_util.h
)
add_library(databaseutil STATIC ${databaseutil_SRCS})

set(crosscompileutil_SRCS
    cross_compile.cpp
    cross_compile.h
    )
add_library(crosscompileutil STATIC ${crosscompileutil_SRCS})

=== debian/changelog ===
vectorscan (5.4.9-1) unstable; urgency=medium

  * New upstream release 

 -- Konstantinos Margaritis <markos@debian.org>  Thu, 23 Mar 2023 17:30:47 +0200

vectorscan (5.4.8-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Temporarily remove broken ppc64el. (Closes: #1021079)

 -- Adam Borowski <kilobyte@angband.pl>  Sun, 22 Jan 2023 14:10:20 +0100

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Priority: optional
 Maintainer: Konstantinos Margaritis <markos@debian.org>
 Build-Depends: cmake,
-               debhelper-compat (= 12),
+               debhelper-compat (= 13),
                libboost-dev,
                libpcap-dev,
                pkg-config,

=== debian/rules ===
--- 
+++ 
@@ -14,6 +14,3 @@
 		-DBUILD_STATIC_AND_SHARED=1 \
 		-DCMAKE_BUILD_TYPE=RelWithDebInfo \
 		${DEB_CMAKE_FLAGS}
-
-override_dh_missing:
-	dh_missing --fail-missing
